#region Copyright
/*
 * Copyright 2005-2006 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
#endregion

using System;
using System.Data;
using System.Data.OleDb;
using System.Data.Odbc;
using System.Reflection;
using System.Resources;
using Seasar.Extension.ADO;

namespace Seasar.Dao.Dbms
{
    public sealed class DbmsManager
    {
        private static ResourceManager resourceManager;

        static DbmsManager()
        {
            resourceManager = new ResourceManager(
                "Dbms", Assembly.GetExecutingAssembly());
        }

        private DbmsManager()
        {
        }

        public static IDbms GetDbms(IDataSource dataSource)
        {
            // IDbConnectionDataSource擾
            IDbConnection cn = dataSource.GetConnection();

            //IDbms̎NX擾邽߂Key
            string dbmsKey = null;

            if(cn is OleDbConnection)
            {
                // OleDbConnection̏ꍇKeyTypeProvider쐬
                OleDbConnection oleDbCn = cn as OleDbConnection;
                dbmsKey = cn.GetType().Name + "_" + oleDbCn.Provider;
            }
            else if(cn is OdbcConnection)
            {
                // OdbcConnection̏ꍇKeyTypeDriver쐬
                OdbcConnection odbcCn = cn as OdbcConnection;
                dbmsKey = cn.GetType().Name + "_" + odbcCn.Driver;
            }
            else
            {
                dbmsKey = cn.GetType().Name;
            }

            // KeyIDbmsNX̃CX^X擾
            return GetDbms(dbmsKey);
        }

        /// <summary>
        /// Dbms.resxdbmsKeyŒTAIDbmsNX̃CX^X擾
        /// </summary>
        /// <param name="dbmsKey">Dbms.resxׂKey</param>
        /// <returns>IDbmsNX̃CX^X</returns>
        /// <remarks>dbmsKeyɑΉ̂Ȃꍇ́A
        /// WStandardgp</remarks>
        public static IDbms GetDbms(string dbmsKey)
        {
            // Dbms.resxIDbms̎NX擾
            string typeName = resourceManager.GetString(dbmsKey);

            // IDbmsNXType擾
            // Dbms.resxɑΉIDbmsNXꍇ́AWStandardgp
            Type type = typeName == null ? typeof(Standard) : Type.GetType(typeName);

            // IDbmsNX̃CX^X쐬ĕԂ
            return (IDbms) Activator.CreateInstance(type, false);
        }
    }
}
